All of lore.kernel.org
 help / color / mirror / Atom feed
From: Ishani Chugh <chugh.ishani@research.iiit.ac.in>
To: qemu-devel@nongnu.org
Cc: stefanha@redhat.com, jsnow@redhat.com,
	Ishani Chugh <chugh.ishani@research.iiit.ac.in>
Subject: [Qemu-devel] [PATCH 2/3] Test for full Backup
Date: Tue, 29 Aug 2017 19:18:00 +0530	[thread overview]
Message-ID: <1504014481-7975-3-git-send-email-chugh.ishani@research.iiit.ac.in> (raw)
In-Reply-To: <1504014481-7975-1-git-send-email-chugh.ishani@research.iiit.ac.in>

This patch is the test for full backup implementation in Backup tool.
The test employs two basic substests:
1) Backing up an empty guest and comparing it with base image.
2) Writing a pattern to the guest, creating backup and comparing
   with the base image.

Signed-off-by: Ishani Chugh <chugh.ishani@research.iiit.ac.in>
---
 tests/qemu-iotests/191     | 86 ++++++++++++++++++++++++++++++++++++++++++++++
 tests/qemu-iotests/191.out | 35 +++++++++++++++++++
 tests/qemu-iotests/group   |  2 ++
 3 files changed, 123 insertions(+)
 create mode 100755 tests/qemu-iotests/191
 create mode 100644 tests/qemu-iotests/191.out

diff --git a/tests/qemu-iotests/191 b/tests/qemu-iotests/191
new file mode 100755
index 0000000..16988d8
--- /dev/null
+++ b/tests/qemu-iotests/191
@@ -0,0 +1,86 @@
+#!/bin/bash
+#
+# Test full backup functionality of qemu-backup tool
+#
+# Copyright (C) 2017 Ishani Chugh <chugh.ishani@research.iiit.ac.in>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+# creator
+owner=chugh.ishani@research.iiit.ac.in
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+here=`pwd`
+status=1	# failure is the default!
+
+
+# get standard environment, filters and checks
+. ./common.rc
+. ./common.filter
+. ./common.qemu
+
+_supported_fmt generic
+_supported_proto generic
+_supported_os Linux
+
+_cleanup()
+{
+        rm -f "$TEST_DIR"/virtio0
+        rm -f "$CONFIG_FILE"
+}
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+CONFIG_FILE="$TEST_DIR"/backup-config
+SOCKET=unix:"$TEST_DIR"/backup_socket
+size=128M
+
+_make_test_img "$size"
+export QEMU_BACKUP_CONFIG="$CONFIG_FILE"
+qemu_comm_method="monitor"
+echo
+_launch_qemu -drive if=virtio,file="$TEST_IMG" -qmp "$SOCKET",server,nowait
+$PYTHON ../../contrib/backup/qemu-backup.py guest add --guest adad --qmp "$SOCKET"
+$PYTHON ../../contrib/backup/qemu-backup.py drive add --id virtio0 --guest adad --target "$TEST_DIR"/virtio0
+echo
+echo "== Creating backup =="
+$PYTHON ../../contrib/backup/qemu-backup.py backup --guest adad
+_send_qemu_cmd $QEMU_HANDLE 'quit' ''
+wait=1 _cleanup_qemu
+echo
+echo "== Comparing images =="
+$QEMU_IMG compare "$TEST_DIR"/virtio0 "$TEST_IMG"
+_cleanup
+
+_launch_qemu -drive if=virtio,id=virtio0,file="$TEST_IMG" -qmp "$SOCKET",server,nowait
+$PYTHON ../../contrib/backup/qemu-backup.py guest add --guest adad --qmp "$SOCKET"
+$PYTHON ../../contrib/backup/qemu-backup.py drive add --id virtio0 --guest adad --target "$TEST_DIR"/virtio0
+echo
+echo "== Writing Pattern =="
+_send_qemu_cmd $QEMU_HANDLE 'qemu-io virtio0 "write -P 0x22 0 1M"' "(qemu)" | _filter_qemu_io
+echo
+echo "== Creating backup =="
+$PYTHON ../../contrib/backup/qemu-backup.py backup --guest adad
+_send_qemu_cmd $QEMU_HANDLE 'quit' ''
+wait=1 _cleanup_qemu
+echo
+echo "== Comparing images =="
+$QEMU_IMG compare "$TEST_DIR"/virtio0 "$TEST_IMG"
+_cleanup
+_cleanup_test_img
+
+echo "*** done"
+status=0
\ No newline at end of file
diff --git a/tests/qemu-iotests/191.out b/tests/qemu-iotests/191.out
new file mode 100644
index 0000000..c60d47a
--- /dev/null
+++ b/tests/qemu-iotests/191.out
@@ -0,0 +1,35 @@
+QA output created by 191
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=134217728
+
+Successfully Added Guest
+Successfully Added Drive
+
+== Creating backup ==
+Backup Started
+*virtio0
+Backup Complete
+QEMU X.Y.Z monitor - type 'help' for more information
+(qemu) Formatting 'TEST_DIR/virtio0', fmt=qcow2 size=134217728 cluster_size=65536 lazy_refcounts=off refcount_bits=16
+quit
+
+== Comparing images ==
+Images are identical.
+Successfully Added Guest
+Successfully Added Drive
+
+== Writing Pattern ==
+QEMU X.Y.Z monitor - type 'help' for more information
+(qemu) qemu-io virtio0 "write -P 0x22 0 1M"
+
+== Creating backup ==
+Backup Started
+*virtio0
+Backup Complete
+wrote 1048576/1048576 bytes at offset 0
+1 MiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+(qemu) Formatting 'TEST_DIR/virtio0', fmt=qcow2 size=134217728 cluster_size=65536 lazy_refcounts=off refcount_bits=16
+quit
+
+== Comparing images ==
+Images are identical.
+*** done
diff --git a/tests/qemu-iotests/group b/tests/qemu-iotests/group
index afbdc42..66fa231 100644
--- a/tests/qemu-iotests/group
+++ b/tests/qemu-iotests/group
@@ -186,4 +186,6 @@
 188 rw auto quick
 189 rw auto
 190 rw auto quick
+191 rw auto
 192 rw auto quick
+193 rw auto
-- 
2.7.4

  parent reply	other threads:[~2017-08-29 13:48 UTC|newest]

Thread overview: 13+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2017-08-29 13:47 [Qemu-devel] [PATCH 0/3] QEMU Backup Tool Ishani Chugh
2017-08-29 13:47 ` [Qemu-devel] [PATCH 1/3] backup: " Ishani Chugh
2017-08-29 13:48 ` Ishani Chugh [this message]
2017-08-29 13:48 ` [Qemu-devel] [PATCH 3/3] Add manpage for " Ishani Chugh
2017-08-29 14:49 ` [Qemu-devel] [PATCH 0/3] " Eric Blake
2017-08-29 15:52   ` Ishani
  -- strict thread matches above, loose matches on Subject: below --
2017-08-29 15:50 Ishani Chugh
2017-08-29 15:50 ` [Qemu-devel] [PATCH 2/3] Test for full Backup Ishani Chugh
2017-08-23 13:04 [Qemu-devel] [PATCH 0/3] QEMU Backup Tool Ishani Chugh
2017-08-23 13:04 ` [Qemu-devel] [PATCH 2/3] Test for full Backup Ishani Chugh
2017-08-25 14:24   ` Stefan Hajnoczi
2017-08-25 14:36   ` Peter Maydell
2017-08-25 15:15     ` John Snow
2017-08-21 11:10 [Qemu-devel] [PATCH 0/3] QEMU Backup Tool Ishani Chugh
2017-08-21 11:10 ` [Qemu-devel] [PATCH 2/3] Test for full Backup Ishani Chugh
2017-08-22 15:21   ` Stefan Hajnoczi

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1504014481-7975-3-git-send-email-chugh.ishani@research.iiit.ac.in \
    --to=chugh.ishani@research.iiit.ac.in \
    --cc=jsnow@redhat.com \
    --cc=qemu-devel@nongnu.org \
    --cc=stefanha@redhat.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.